import bisect
from Crypto.PublicKey import RSA

KEEP = 2000

def find_sols_Kplusone(n, solsK):
	solsk = []
	seen = {}

	n_mod_k = n % 2**k
	for weight, p,q in solsK:
		p2 = p + 2**k
		q2 = q + 2**k
		n1 = p*q % 2**k
		n2 = p2*q % 2**k
		n3 = p*q2 % 2**k
		n4 = p2*q2 % 2**k

		if n1 == n_mod_k and (p,q) not in seen:
			bisect.insort(solsk, ((weight, p,q)))
			seen[(p,q)] = True
			seen[(q,p)] = True

		if n2 == n_mod_k and (p,q2) not in seen:
			bisect.insort(solsk, ((weight+1, p,q2)))
			seen[(p,q2)] = True
			seen[(q2,p)] = True

		if n3 == n_mod_k and (p2,q) not in seen:
			bisect.insort(solsk, ((weight+1, p2,q)))
			seen[(p2,q)] = True
			seen[(q,p2)] = True

		if n4 == n_mod_k and (p2,q2) not in seen:
			bisect.insort(solsk, ((weight+2, p2,q2)))
			seen[(p2,q2)] = True
			seen[(q2,p2)] = True

	return solsk[:KEEP]


with open('pubkey.pem','rb') as f:
	key = RSA.import_key(f.read())

n = key.n 

sols = [(2,1,1)]

for k in range(1, 1022):
	print(k,'/',1024,len(sols))
	sols = find_sols_Kplusone(n, sols)

for w,p,q in sols:
	p2 = p + 2**1023 + 2**1022
	q2 = q + 2**1023 + 2**1022
	if n % p2 == 0 or n % q2 == 0:
		print('Found it:', p2)
		break